/* up2b64.p
 *
 * base64 encode a username & password
 *
 * pro -p util/up2b64.p
 *
 * this is just obfuscation of what would otherwise be clear-text
 * credentials, it is not intended to be "fort knox" strength
 * encryption
 *
 * this encoding is useful for HTTP "Authorization: Basic" headers
 *
 */

define variable username   as character no-undo format "x(30)".
define variable password   as character no-undo format "x(30)".
define variable credential as character no-undo.

define variable authMemptr as memptr    no-undo.
define variable authString as character no-undo format "x(30)".

define variable ii as integer no-undo.
define variable nn as integer no-undo.

update
  username skip
  password skip
.

credential = substitute( "&1:&2", username, password ).
nn = length( credential ).

set-size( authMemptr ) = nn.
set-byte-order( authMemptr ) = big-endian.
do ii = 1 to nn:
  put-byte( authMemptr, ii ) = asc( substring( credential, ii, 1 )).
end.
authString = string( base64-encode( authMemptr )).
set-size( authMemptr ) = 0.

display authString.
